import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import javax.swing.*;
import java.util.*;

/**
 * Rg[NX.
 */
public class KCtrlPZL extends KCtrl implements KConstant {

	/**
	 * tF[Y.
	 */
	private final int PHASE_INIT		= 0;
	private final int PHASE_TITLE		= 1;
	private final int PHASE_STAGE_START	= 2;
	private final int PHASE_RUN			= 3;
	private final int PHASE_FAIL		= 4;
	private final int PHASE_END			= 5;
	private final int PHASE_STOP		= -1;

	/**
	 * x.
	 */
	private final int SPEED				= 16;

	/**
	 * ǉubNǉ܂ł̎.
	 */
	private final int TIME_ADD_BLOCK	= 2;

	/**
	 * pl.
	 */
	private		KPanel				panel				= null;

	/**
	 * C[W.
	 */
	private		BufferedImage		imageBackground		= null;
	private		BufferedImage		imageBlock00_01		= null;
	private		BufferedImage		imageBlock00_02		= null;
	private		BufferedImage		imageBlock00_03		= null;
	private		BufferedImage		imageBlock01		= null;
	private		BufferedImage		imageBlock02		= null;
	private		BufferedImage		imageBlock03		= null;
	private		BufferedImage		imageBlock04		= null;
	private		BufferedImage		imageBlock05		= null;
	private		BufferedImage		imageBlockAA		= null;

	/**
	 * XvCg.
	 * S̓Iɕ\XvCǵAŊǗB
	 */
	private		KSpriteBackground	spriteBackground	= null;

	/**
	 * eLXg.
	 */
	private		KTextTitle			kTextTitle			= null;
	private		KText				kTextStart			= null;
	private		KText				kTextBy				= null;
	private		KText				kTextEnd			= null;
	private		KText				kTextScoreHigh		= null;
	private		KText				kTextScore			= null;
	private		KText				kTextStage			= null;
	private		KText				kTextLimit			= null;
	private		KText				kTextMessage		= null;

	/**
	 * XvCgubNꗗ.
	 */
	private		KSpriteBlock01[][]	sprBlocks			= new KSpriteBlock01[BLOCK_ROW_COUNT][BLOCK_COL_COUNT];

	/**
	 * ǉubN.
	 */
	private		int[]				addBlocks			= new int[BLOCK_COL_COUNT];

	/**
	 * XvCgubNꗗ.
	 */
	private		ArrayList<KSpriteBlock01>	sprFallBlockLst		= new ArrayList<KSpriteBlock01>(100);

	/**
	 * 폜Ԉꗗ.
	 */
	private		ArrayList<String>		timeLst				= new ArrayList<String>();

	/**
	 * 폜XvCgubNꗗꗗ.
	 */
	private		ArrayList<ArrayList<KSpriteBlock01>>	deleteSprBlockLstLst		= new ArrayList<ArrayList<KSpriteBlock01>>();

	/**
	 * tF[Y.
	 */
	private		int					phase				= PHASE_INIT;

	/**
	 * XRA.
	 */
	private		int					score				= 0;

	/**
	 * nCXRA.
	 */
	private		int					scoreHigh			= 10000;

	/**
	 * Xe[W.
	 */
	private		int					stage				= 1;

	/**
	 * .
	 */
	private		int					time				= 0;

	/**
	 * .
	 */
	private		int					limit				= 0;

	/**
	 * }EXA_v^.
	 */
	private		KCPMouseAdapter		kcpMouseAdapter		= null;

	/**
	 * RXgN^.
	 * @param con Rei
	 */
	public KCtrlPZL(Container con){

		super(con);

		try{

			// pl𐶐
			panel = new KPanel(this);

			// pl̃TCYݒ
			panel.setSize(KConstant.WIDTH, KConstant.HEIGHT);
			panel.setPreferredSize(new Dimension(KConstant.WIDTH, KConstant.HEIGHT));

			// XvCgw̐ݒ
			panel.setLayoutCount(LAYOUT_COUNT);

			// C[W擾
			imageBackground = KImage.getImage("imageBackground.jpg");
			imageBlock00_01 = KImage.getImage("imageBlock00_01.gif");
			imageBlock00_02 = KImage.getImage("imageBlock00_02.gif");
			imageBlock00_03 = KImage.getImage("imageBlock00_03.gif");
			imageBlock01 = KImage.getImage("imageBlock01.gif");
			imageBlock02 = KImage.getImage("imageBlock02.gif");
			imageBlock03 = KImage.getImage("imageBlock03.gif");
			imageBlock04 = KImage.getImage("imageBlock04.gif");
			imageBlock05 = KImage.getImage("imageBlock05.gif");
			imageBlockAA = KImage.getImage("imageBlockAA.gif");

			// C[WXvCgɓo^
			KSpriteBackground.setImage(KSpriteBackground.class, imageBackground);
			KSpriteBlock00.setImage(KSpriteBlock00.class, new BufferedImage[]{imageBlock00_01, imageBlock00_02, imageBlock00_03});
			KSpriteBlock01.setImage(KSpriteBlock01.class, new BufferedImage[]{imageBlock01, imageBlock02, imageBlock03, imageBlock04, imageBlock05});
			KSpriteBlockAA.setImage(KSpriteBlockAA.class, imageBlockAA);

			// wi
			spriteBackground = new KSpriteBackground(panel);

			//
			// eeLXg𐶐
			//

			kTextTitle = new KTextTitle(panel, 0, 0);

			kTextStart = new KText(panel, 176, 400);
			kTextStart.setFont(new Font("HGۺ޼M-PRO", Font.PLAIN, 16));
			kTextStart.setText("CLICK MOUSE BUTTON");

			kTextBy = new KText(panel, 200, 480);
			kTextBy.setFont(new Font("lr SVbN", Font.PLAIN, 12));
			kTextBy.setText("PROGRAMED  BY  KIN");

			kTextEnd = new KText(panel, 250, 300);
			kTextEnd.setFont(new Font("HGۺ޼M-PRO", Font.PLAIN, 16));
			kTextEnd.setText("GAME OVER");

			kTextScoreHigh = new KText(panel, 50, 20);
			panel.addText("HIGH-SCORE", kTextScoreHigh);

			kTextScore = new KText(panel, 200, 20);
			panel.addText("SCORE", kTextScore);

			kTextStage = new KText(panel, 350, 20);
			panel.addText("STAGE", kTextStage);

			kTextLimit = new KText(panel, 350, 36);
			panel.addText("LIMIT", kTextLimit);

			kTextMessage = new KText(panel, 240, 100);
			kTextMessage.setFont(new Font("HGۺ޼M-PRO", Font.BOLD, 24));

			// }EXA_v^
			kcpMouseAdapter = new KCPMouseAdapter();

			// }EXA_v^plɓo^
			panel.addMouseListener(kcpMouseAdapter);
			panel.addMouseMotionListener(kcpMouseAdapter);

		// G[̏ꍇA
		}catch(Exception ex){
			// X^bNg[Xo
			ex.printStackTrace();
			// G[\
			JOptionPane.showMessageDialog(null, ex.toString());
		}

	} // end KCtrlPZL

	/**
	 * Jn.
	 * <pre>
	 * IuWFNg̏Jn܂B
	 * </pre>
	 */
	public void start(){

		// plɃtH[JX𓖂Ă
		panel.requestFocus();

		// plJn
		panel.start();

		// tF[Y
		this.phase = PHASE_INIT;

	} // end start

	/**
	 * s.
	 * <pre>
	 * IuWFNĝӂ܂肵܂B
	 * </pre>
	 */
	public void run(){

		// tF[Y
		switch(this.phase){

			// tF[Y
			case PHASE_INIT:

				// XRA
				score = 0;

				// Xe[W
				stage = 1;

				// ԏ
				time = 0;

				// ԏ
				limit = LIMIT_INIT;

				// ubÑXvCgw
				panel.initKSpriteLstInLayout(LAYOUT_BLK0);
				panel.initKSpriteLstInLayout(LAYOUT_BLK1);

				// wĩXvCgw
				panel.initKSpriteLstInLayout(LAYOUT_HAIKEI0);
				panel.initKSpriteLstInLayout(LAYOUT_HAIKEI1);
				panel.initKSpriteLstInLayout(LAYOUT_HAIKEI2);

				// XvCgO[v
				panel.initSpriteGroup();

				// wio^
				panel.addSprite(LAYOUT_HAIKEI0, spriteBackground);

				// ^Cg\
				panel.addText("TITLE", kTextTitle);
				panel.addText("START", kTextStart);
				panel.addText("BY", kTextBy);

				// eeLXgŐV
				kTextScoreHigh.setText("HIGH-SCORE : " + Integer.toString(scoreHigh));

				// XRA
				kTextScore.setText("SCORE : " + Integer.toString(score));

				// Xe[W
				kTextStage.setText("STAGE : " + Integer.toString(stage));

				// ԏ
				kTextLimit.setText("LIMIT : " + Integer.toString(limit / 60));

				//
				// ǂ쐬
				//

				// c[v
				for(int row = 0; row < 17; row++){

					KSpriteBlockAA kSpriteBlockAA = new KSpriteBlockAA(panel);
					panel.addSprite(LAYOUT_HAIKEI1, kSpriteBlockAA);
					kSpriteBlockAA.setY(row * 32);

					kSpriteBlockAA = new KSpriteBlockAA(panel);
					panel.addSprite(LAYOUT_HAIKEI1, kSpriteBlockAA);
					kSpriteBlockAA.setX(512);
					kSpriteBlockAA.setY(row * 32);

				} // ewd for c[v

				// [v
				for(int col = 0; col < 17; col++){

					KSpriteBlockAA kSpriteBlockAA = new KSpriteBlockAA(panel);
					panel.addSprite(LAYOUT_HAIKEI1, kSpriteBlockAA);
					kSpriteBlockAA.setX(col * 32);
					kSpriteBlockAA.setY(512);

				} // ewd for [v

				// ^Cg\tF[Y
				this.phase = PHASE_TITLE;

				break;

			// ^Cg\tF[Y
			case PHASE_TITLE:

				break;

			// Xe[WJntF[Y
			case PHASE_STAGE_START:

				time++;

				// READY
				if(time == 1){

					// ^Cg폜
					panel.removeText("TITLE");
					panel.removeText("START");
					panel.removeText("BY");

					// ubN
					initBlocks();

					// ꏊC
					kTextMessage.setX(216);

					// READY
					kTextMessage.setText("READY");

					// READY\
					panel.addText("MESSAGE", kTextMessage);

				// GO!
				}else if(time == 120){

					// ꏊC
					kTextMessage.setX(240);

					// GO!
					kTextMessage.setText("GO!");

				// {GO!
				}else if(time == 180){

					// GO!폜
					panel.removeText("MESSAGE");

					// ԏ
					time = 0;

for(int i = 0; i < BLOCK_COL_COUNT; i++){
	addBlocks[i] = 1;
}

					// ʏtF[Y
					this.phase = PHASE_RUN;

				}

				break;

			// ʏtF[Y
			case PHASE_RUN:

				// Ԃi߂
				time++;

				//
				// ǉubN𗎉
				//

				// ԂꍇA
				if(time % TIME_ADD_BLOCK == 0){

					// 񐔕A[v
					for(int col = 0; col < BLOCK_COL_COUNT; col++){

						// ǉubNꍇA
						if(addBlocks[col] > 0){

							// ǉubNЂƂ炷
							addBlocks[col]--;

							// VubNF擾
							int block = getNewBlock();

							// XvCgubN
							KSpriteBlock01 sprFallBlock = new KSpriteBlock01(panel, block);

							// XYWݒ
							sprFallBlock.setX(col * 32 + 32);
							sprFallBlock.setY(-32);

							// XvCgubNꗗɒǉ
							sprFallBlockLst.add(sprFallBlock);

							// plɃubNǉ
							panel.addSprite(LAYOUT_BLK0, sprFallBlock);

						} // end if ǉubNꍇ

					} // 񐔕A[v

				} // end if Ԃꍇ

				//
				// ubN
				//

				// ubN邩H
				boolean flgFallBlock = (sprFallBlockLst.size() > 0);

				// XvCgubNꗗ̌A[v
				for(int i = 0; i < sprFallBlockLst.size(); i++){

					// XvCgubN擾
					KSpriteBlock01 sprFallBlock = sprFallBlockLst.get(i);

					// XYW擾
					int y = sprFallBlock.getY();
					int x = sprFallBlock.getX();

					// 
					y = y + SPEED;

					// YWݒ
					sprFallBlock.setY(y);

					// ܂̂قŗ̏ꍇA
					if(y < POS_Y){
						// ReBj[
						continue;
					}

					// ̃ubN邩`FbNKvꍇA
					if(y % 32 != 0){
						// ReBj[
						continue;
					}

					// sʒu擾
					int row = getRow(y);
					int col = getCol(x);

					// ԉ܂ŗꍇA
					//   ܂́AubN̉ɃubNꍇ
					if(row == BLOCK_ROW_COUNT - 1 || sprBlocks[row + 1][col] != null){

						// XvCgubNꗗ폜
						sprFallBlockLst.remove(i);

						// [vЂƂ߂
						i--;

						// XvCgubNꗗɐݒ
						sprBlocks[row][col] = sprFallBlock;

					} // end if ubN̉ɃubNꍇ

				} // end for XvCgubNꗗ̌A[v

				// `FbNubN
				ArrayList<int[]> checkLst = new ArrayList<int[]>();

				// XvCgubNSĖȂꍇA
				if(flgFallBlock && sprFallBlockLst.size() == 0){

					// SĂ̍sE`FbNΏۂɂ
					for(int row = 0; row < BLOCK_ROW_COUNT; row++){
						for(int col = 0; col < BLOCK_COL_COUNT; col++){
							checkLst.add(new int[]{row, col});
						}
					}
				} // end if XvCgubNSĖȂꍇ

				//
				// `FbN
				//

				// `FbNKvȏꍇA
				if(checkLst.size() > 0){

					// `FbNA폜XvCgubNꗗ擾
					ArrayList<KSpriteBlock01> deleteSprBlockLst = check(checkLst);

					// 폜ubN擾łꍇA
					if(deleteSprBlockLst != null){

						// 폜Ԉꗗɒǉ
						timeLst.add("0");

						// 폜XvCgubNꗗꗗɒǉ
						deleteSprBlockLstLst.add(deleteSprBlockLst);

					} // end if 폜ubN擾łꍇ

				} // end if `FbNKvȏꍇA

				//
				// 폜
				//

				// Ԉꗗ̌A[v
				for(int i = 0; i < timeLst.size(); i++){

					// Ԃ擾
					int time = Integer.parseInt(timeLst.get(i));

					// Ԃ{P
					time++;

					// Ԃݒ
					timeLst.set(i, String.valueOf(time));

					// C[WύXԂꍇA
					if(time == 1 || time == 10 || time == 20){

						int deleteStage = 0;
						if(time == 1){
							deleteStage = 0;
						}else if(time == 10){
							deleteStage = 1;
						}else{
							deleteStage = 2;
						}

						// 폜ꗗ擾
						ArrayList<KSpriteBlock01> deleteSprBlockLst = deleteSprBlockLstLst.get(i);

						// 폜ꗗ̌A[v
						for(int j = 0; j < deleteSprBlockLst.size(); j++){

							// 폜XvCgubN擾
							KSpriteBlock01 sprBlock = deleteSprBlockLst.get(j);

							// 폜iKݒ肷
							sprBlock.setDeleteStage(deleteStage);

						} // end for 폜ꗗ̌A[v

					// XvCg폜ԂꍇA
					}else if(time == 30){

						// 폜XvCgubNꗗ擾
						ArrayList<KSpriteBlock01> deleteSprBlockLst = deleteSprBlockLstLst.get(i);

						// 폜XvCgubNꗗ̌A[v
						for(int j = 0; j < deleteSprBlockLst.size(); j++){

							// 폜XvCgubN擾
							KSpriteBlock01 sprBlock = deleteSprBlockLst.get(j);

							// XvCg폜
							sprBlock.removeSprite();

							// XvCgubNꗗɓo^ĂꍇA
							if(sprFallBlockLst.indexOf(sprBlock) != -1){

								// XvCgubNꗗ폜
								sprFallBlockLst.remove(sprBlock);

							// XvCgubNꗗɓo^ĂȂꍇA
							// i~܂Ăꍇj
							}else{

								// \ʒu擾
								int y = sprBlock.getY();
								int x = sprBlock.getX();

								// sʒu擾
								int row = getRow(y);
								int col = getCol(x);

								// XvCgubNꗗ폜
								sprBlocks[row][col] = null;

								// ̃ubNA[v
								for(int row1 = row - 1; row1 >= 0; row1--){

									// XvCgubN擾
									sprBlock = sprBlocks[row1][col];

									// XvCgubN݂ꍇA
									if(sprBlock != null){

										// XvCgubNꗗ폜
										sprBlocks[row1][col] = null;

										// XvCgubNꗗɒǉ
										sprFallBlockLst.add(sprBlock);

									} // end if XvCgubN݂ꍇ

								} // end for ̃ubNA[v

							} // end if XvCgubNꗗɓo^ĂȂꍇ

						} // end for 폜XvCgubNꗗ̌A[v

						// 폜XvCgubNꗗ̌A[v
						for(int j = 0; j < deleteSprBlockLst.size(); j++){

							// 폜XvCgubN擾
							KSpriteBlock01 sprBlock = deleteSprBlockLst.get(j);

							// \ʒu擾
							int x = sprBlock.getX();

							// ǉubNꗗɒǉ
							addBlocks[getCol(x)]++;

							// XRAZ
							addScore(10);

						} // end for 폜XvCgubNꗗ̌A[v

						// Ԉꗗ폜
						timeLst.remove(i);

						// 폜XvCgubNꗗꗗ폜
						deleteSprBlockLstLst.remove(i);

						// [vЂƂ߂
						i--;

					} // end if XvCg폜Ԃꍇ

				} // end for Ԉꗗ̌A[v

				// ԌvZ
				limit--;

				// ԕ\
				kTextLimit.setText("LIMIT : " + Integer.toString(limit / 60));

				break;

			// stF[Y
			case PHASE_FAIL:

				break;

			// Q[I[o[tF[Y
			case PHASE_END:

				break;

			default:
				break;

		} // end switch tF[Y

	} // end run

	/**
	 * `FbN.
	 * <pre>
	 * 폜łubNꍇ́AArrayListԋp܂B
	 * 폜łubNȂꍇ́Anullԋp܂B
	 * </pre>
	 * @return ArrayList<KSpriteBlock01> 폜XvCgubNꗗ
	 */
	private ArrayList<KSpriteBlock01> check(ArrayList<int[]> checkLst){

		// 폜tO
		boolean flgDelete = false;

		// 폜ubNꗗ
		int[][] deleteBlocks = new int[BLOCK_ROW_COUNT][BLOCK_COL_COUNT];

		// `FbNubNA[v
		for(int i = 0; i < checkLst.size(); i++){

			int[] checks = checkLst.get(i);

			int row = checks[0];
			int col = checks[1];

			// Ƀ`FbNIĂꍇA
			if(deleteBlocks[row][col] != CHECK_NO_CHECK){
				// ReBj[
				continue;
			}

			// ubNF擾
			int color = sprBlocks[row][col].getColor();

			// 폜ꗗ
			ArrayList<int[]> deleteKohoLst	= new ArrayList<int[]>();

			// `FbN󋵈ꗗ
			int[][] checkedDeletes = new int[BLOCK_ROW_COUNT][BLOCK_COL_COUNT];

			// `FbN󋵈ꗗɔfB폜ƂB
			checkedDeletes[row][col] = CHECK_DELETE;

			// 폜ꗗɒǉ
			deleteKohoLst.add(new int[]{row, col});

			// 폜ꗗ̌A[v
			for(int j = 0; j < deleteKohoLst.size(); j++){

				int row0 = deleteKohoLst.get(j)[0];
				int col0 = deleteKohoLst.get(j)[1];

				// 

				// ԍł͂ȂꍇA
				if(col0 > 0){

					// ʒu
					int row1 = row0;
					int col1 = col0 - 1;

					// `FbN  폜ubNꗗɓo^ĂȂꍇA
					if(checkedDeletes[row1][col1] == CHECK_NO_CHECK && deleteBlocks[row1][col1] == CHECK_NO_CHECK){

						// XvCgubN݂ȂꍇA
						if(sprBlocks[row1][col1] == null){

							// `FbN󋵈ꗗɔfBcB
							checkedDeletes[row1][col1] = CHECK_LEAVE;

						// F̏ꍇA
						}else if(sprBlocks[row1][col1].getColor() == color){

							// `FbN󋵈ꗗɔfB폜ɂ
							checkedDeletes[row1][col1] = CHECK_DELETE;

							// 폜ꗗɒǉ
							deleteKohoLst.add(new int[]{row1, col1});

						// FłȂꍇA
						}else{

							// `FbN󋵈ꗗɔfBcB
							checkedDeletes[row1][col1] = CHECK_LEAVE;

						}

					} // end if `FbN̏ꍇ

				} // end if ԍł͂Ȃꍇ

				// E

				// ԉEł͂ȂꍇA
				if(col0 < BLOCK_COL_COUNT - 1){

					// ʒu
					int row1 = row0;
					int col1 = col0 + 1;

					// `FbN  폜ubNꗗɓo^ĂȂꍇA
					if(checkedDeletes[row1][col1] == CHECK_NO_CHECK && deleteBlocks[row1][col1] == CHECK_NO_CHECK){

						// XvCgubN݂ȂꍇA
						if(sprBlocks[row1][col1] == null){

							// `FbN󋵈ꗗɔfBcB
							checkedDeletes[row1][col1] = CHECK_LEAVE;

						// F̏ꍇA
						}else if(sprBlocks[row1][col1].getColor() == color){

							// `FbN󋵈ꗗɔfB폜ɂ
							checkedDeletes[row1][col1] = CHECK_DELETE;

							// 폜ꗗɒǉ
							deleteKohoLst.add(new int[]{row1, col1});

						// FłȂꍇA
						}else{

							// `FbN󋵈ꗗɔfBcB
							checkedDeletes[row1][col1] = CHECK_LEAVE;

						}

					} // end if `FbN̏ꍇ

				} // end if ԉEł͂Ȃꍇ

				// 

				// ԏł͂ȂꍇA
				if(row0 > 0){

					// ʒu
					int row1 = row0 - 1;
					int col1 = col0;

					// `FbN  폜ubNꗗɓo^ĂȂꍇA
					if(checkedDeletes[row1][col1] == CHECK_NO_CHECK && deleteBlocks[row1][col1] == CHECK_NO_CHECK){

						// XvCgubN݂ȂꍇA
						if(sprBlocks[row1][col1] == null){

							// `FbN󋵈ꗗɔfBcB
							checkedDeletes[row1][col1] = CHECK_LEAVE;

						// F̏ꍇA
						}else if(sprBlocks[row1][col1].getColor() == color){

							// `FbN󋵈ꗗɔfB폜ɂ
							checkedDeletes[row1][col1] = CHECK_DELETE;

							// 폜ꗗɒǉ
							deleteKohoLst.add(new int[]{row1, col1});

						// FłȂꍇA
						}else{

							// `FbN󋵈ꗗɔfBcB
							checkedDeletes[row1][col1] = CHECK_LEAVE;

						}

					} // end if `FbN̏ꍇ

				} // end if ԏł͂Ȃꍇ

				// 

				// ԉł͂ȂꍇA
				if(row0 < BLOCK_ROW_COUNT - 1){

					// ʒu
					int row1 = row0 + 1;
					int col1 = col0;

					// `FbN  폜ubNꗗɓo^ĂȂꍇA
					if(checkedDeletes[row1][col1] == CHECK_NO_CHECK && deleteBlocks[row1][col1] == CHECK_NO_CHECK){

						// XvCgubN݂ȂꍇA
						if(sprBlocks[row1][col1] == null){

							// `FbN󋵈ꗗɔfBcB
							checkedDeletes[row1][col1] = CHECK_LEAVE;

						// F̏ꍇA
						}else if(sprBlocks[row1][col1].getColor() == color){

							// `FbN󋵈ꗗɔfB폜ɂ
							checkedDeletes[row1][col1] = CHECK_DELETE;

							// 폜ꗗɒǉ
							deleteKohoLst.add(new int[]{row1, col1});

						// FłȂꍇA
						}else{

							// `FbN󋵈ꗗɔfBcB
							checkedDeletes[row1][col1] = CHECK_LEAVE;

						}

					} // end if `FbN̏ꍇ

				} // end if ԉł͂Ȃꍇ

			} // end for 폜ꗗ̌A[v

			// 폜ꗗRȏ̏ꍇA
			if(deleteKohoLst.size() >= 3){

				// 폜tO폜ɂ
				flgDelete = true;

				// 폜ꗗ̌A[v
				for(int j = 0; j < deleteKohoLst.size(); j++){

					// 폜擾
					row = deleteKohoLst.get(j)[0];
					col = deleteKohoLst.get(j)[1];

					// 폜ubNꗗɍ폜ݒ
					deleteBlocks[row][col] = CHECK_DELETE;

				} // end for 폜ꗗ̌A[v

			} // end if 폜ꗗRȏ̏ꍇ

		} // end for `FbNubNA[v

		// 폜̏ꍇA
		if(flgDelete){

			// 폜XvCgubNꗗ𐶐
			ArrayList<KSpriteBlock01> deleteSprBlockLst	= new ArrayList<KSpriteBlock01>();

			// s[v
			for(int row = 0; row < BLOCK_ROW_COUNT; row++){

				//  [v
				for(int col = 0; col < BLOCK_COL_COUNT; col++){

					// 폜̏ꍇA
					if(deleteBlocks[row][col] == CHECK_DELETE){

						// XvCgubN擾
						KSpriteBlock01 sprBlock = sprBlocks[row][col];

						// 폜XvCgubNꗗɒǉ
						deleteSprBlockLst.add(sprBlock);

					} // end if 폜̏ꍇ

				} // end for 񃋁[v

			} // end for s[v

			// 폜XvCgubNꗗ^[
			return deleteSprBlockLst;

		} // end if 폜̏ꍇA

		// nullŃ^[
		return null;

	} // end check

	/**
	 * pl擾.
	 * @return KPanel pl
	 */
	public KPanel getKPanel(){

		// pl^[
		return this.panel;

	}

	/**
	 * }EXCxg.
	 * <pre>
	 * }EXCxgɂ鐧s܂B
	 * </pre>
	 * @param me }EXCxg
	 */
	public void mouseEvent(MouseEvent me){

		// tF[Y
		switch(this.phase){

			// ^CgʃtF[Y
			case PHASE_TITLE:

				// NbNȊOA
				if(me.getID() != MouseEvent.MOUSE_CLICKED){
					// ^[
					return;
				}

				// Xe[WJntF[Y
				phase = PHASE_STAGE_START;

				break;

			default:
				break;

		} // end switch tF[Y

	} // end mouseEvent

	/**
	 * ubN.
	 */
	private void initBlocks(){

		// s[v
		for(int row = 1; row < BLOCK_ROW_COUNT; row++){

			// 񃋁[v
			for(int col = 0; col < BLOCK_COL_COUNT; col++){

				// XvCgubN𐶐
				KSpriteBlock01 sprBlock =  new KSpriteBlock01(panel, getNewBlock());

				// XvCgubNꗗɐݒ
				sprBlocks[row][col] = sprBlock;

				// ubNʒuݒ
				sprBlock.setY(POS_Y + row * 32);
				sprBlock.setX(POS_X + col * 32);

				// plɃubNǉ
				panel.addSprite(LAYOUT_BLK0, sprBlock);

			} // end for 񃋁[v

		} // end for s[v

	} // end initBlocks

	/**
	 * VubNF擾.
	 * <pre>
	 * Xe[WlubNFԂ܂B
	 * </pre>
	 * @return int VubNF
	 */
	private int getNewBlock(){
		return (int)(Math.random() * (stage + 2));
	}

	/**
	 * XRAZ.
	 * <pre>
	 * XRAZꍇ́AĂяoĂB
	 * </pre>
	 * @param scoreAdd ǉ_
	 */
	public void addScore(int scoreAdd){

		// XRAZ
		this.score = this.score + scoreAdd;

		// XRA\
		kTextScore.setText("SCORE : " + Integer.toString(score));

		// nCXRAXVꂽꍇA
		if(this.score > this.scoreHigh){
		
			// nCXRAu
			this.scoreHigh = this.score;

			// nCXRA\
			kTextScoreHigh.setText("HIGH-SCORE : " + Integer.toString(scoreHigh));

		} // end if nCXRAXVꂽꍇ

		// Xe[Wi߂ꍇA
		if(score > stage * 10000){

			// Ԃ
			limit = LIMIT_INIT;

			// Xe[Wi߂
			stage++;

			// Xe[W\
			kTextStage.setText("STAGE : " + Integer.toString(stage));

		} // end ifXe[Wi߂ꍇ

	} // end addScore

	/**
	 * sʒu擾.
	 * <pre>
	 * pl̈ʒuYsʒu擾܂B
	 * ubNʒuł͂ȂĂAzIȈʒuԂ܂B
	 * </pre>
	 * @param y ʒuY
	 * @return int sʒu
	 */
	private int getRow(int y){

		// sʒu^[
		return (y - POS_Y) / 32;

	} // end getRow

	/**
	 * ʒu擾.
	 * <pre>
	 * pl̈ʒuXʒu擾܂B
	 * ubNʒuł͂ȂĂAzIȈʒuԂ܂B
	 * </pre>
	 * @param x ʒuX
	 * @return int ʒu
	 */
	private int getCol(int x){

		// ʒu^[
		return (x - POS_X) / 32;

	} // end getCol

	/**
	 * XvCgubNʒuY擾.
	 * <pre>
	 * sʒupl̈ʒuY擾܂B
	 * </pre>
	 * @param row sʒu
	 * @return int ʒuY
	 */
	private int getYSprBlock(int row){

		// ubNʒu^[
		return POS_Y + row * 32;

	} // end getYSprBlock

	/**
	 * XvCgubNʒuX擾.
	 * <pre>
	 * ʒupl̈ʒuX擾܂B
	 * </pre>
	 * @param col ʒu
	 * @return int ʒuX
	 */
	private int getXSprBlock(int col){

		// ubNʒu^[
		return POS_X + col * 32;

	} // end getXSprBlock

	/**
	 * }EXCxg.
	 */
	private class KCPMouseAdapter extends MouseAdapter {

		/**
		 * }EXNbN.
		 */
		public void mouseClicked(MouseEvent me){

			// X[p[NXĂяo
			super.mouseClicked(me);

			// }EXCxgĂяo
			KCtrlPZL.this.mouseEvent(me);

		} // end mouseClicked

	} // end KCPMouseAdapter

}
